import io

def shareKey(filename, username, perm):
    rkey = io.get(filename)[0]
    efname = io.getEncName(filename, rkey)
    data = io.read(efname, rkey)
    csum, perms, contents = io.parse(data)
    fcontent = io.format(csum, ','.join(perms.split(',')+[username+':'+perm]), contents)
    io.write(efname, fcontent, rkey)
    return io.get(filename)[0].encode('hex')

def unlock(filename, key):
    rkey = key.decode('hex')
    io.setKey(filename,rkey, '1')
    io.setKey(io.getEncName(filename, rkey),rkey,'1')